﻿using UnityEngine;
using System.Collections;

public class GameGUI : MonoBehaviour 
{
    public GUIStyle centerStyle;

    public int textY, textWidth, textHeight;
    private int textX;

    //make pause appear in the center of the screen
    private float pauseWidth = 0.5f, pauseHeight = 0.5f; 
    private Rect pausePosition;

    private Rect lifePosition;
    private Rect coinPosition;
    public int lifeIconWidth;
    public int lifeIconHeight;
    public Texture2D lifeIcon; 
    public Texture2D CoinIcon; 

    public static int numberOfCoins = 0;
    public static int numberOfLives = 3;

    void Start()
    {
        //position the x coordinate based on the screen size so it will always fit
        textX = Screen.width - textWidth - (int)(Screen.width * 0.30f) -50;

        //position the pause message at the center of the screen
        pausePosition.x = (Screen.width*(1-pauseWidth))/2;
        pausePosition.y = (Screen.height*(1-pauseHeight))/2;
        pausePosition.width = Screen.width*pauseWidth;
        pausePosition.height = Screen.height*pauseHeight;

        //make life position relative to coin position
        lifePosition.x = textX + 50;
        lifePosition.y = textY;
        lifePosition.width = 20;
        lifePosition.height = 20;

        //make life position relative to coin position
        coinPosition.x = textX - 20;
        coinPosition.y = textY;
        coinPosition.width = 20;
        coinPosition.height = 20;

        //centering style for pause text
        centerStyle.alignment = TextAnchor.MiddleCenter;
    }

    void OnGUI()
    {
        GUI.color = Color.white;
        GUI.Label(new Rect(textX,textY,textWidth,textHeight), "X"+numberOfCoins);
        GUI.Label(new Rect(textX+75,textY,textWidth,textHeight), "X"+numberOfLives);
        GUI.DrawTexture(lifePosition, lifeIcon);
        GUI.DrawTexture(coinPosition, CoinIcon);


        //GUI.

        if (PlayerController.isPaused && !PlayerController.isGameOver)
        {
           //print out the pause message
            GUI.Label(pausePosition, "PAUSED", centerStyle);

        }

        if (PlayerController.isGameOver && !PlayerController.isDying)
        {
            GUI.Label(pausePosition, "GAME OVER", centerStyle);
        }
    }
}//end script