﻿using UnityEngine;
using System.Collections;

/*Script controller the behavior of goombas*/

public class GoombaController : MonoBehaviour 
{
    private Animator animator;


    public int turnTime;
    private int patrolTime = 0;
    public int speed;

    public static bool hasHitMario = false;

    private bool isMoving = false;
    private bool isDying = false;


	void Start () 
    {
        this.animator = GetComponent<Animator>();

	}
	
	void Update ()
    {

        if (!PlayerController.isPaused)
        {
            if (!isDying)
            {
                Patrol();
            }


            Die();
        }
	}


    void Patrol()
    {
        if(!isMoving)
        {
            isMoving = true;
            InvokeRepeating("PatrolTimer", 0, 1);
        }
        else if (isMoving)
        {
            transform.Translate(-1 * speed * Time.deltaTime, 0f, 0f);
        }
    }//end patrol

    void PatrolTimer()
    {
        //a patrol time of 1 is the same as standing still otherwise we will patrol back and forth every patrolTime seconds -1 
        patrolTime++;

        if (patrolTime == turnTime)
        {
            speed *= -1;
            patrolTime = 0;
            isMoving = false;
            CancelInvoke();
        }
            
    }//end patrol timer

    void Die()
    {
        if (PlayerController.isSmashing && !this.isDying)
        {
            GetComponent<CircleCollider2D>().enabled = false;
            GetComponent<EdgeCollider2D>().enabled = false;

            if (!SoundEffects.squish.isPlaying)
                SoundEffects.squish.Play();
      
            this.isDying = true;
            //gameObject.layer = LayerMask.NameToLayer( "Player" ).
            gameObject.layer = LayerMask.NameToLayer("NULL");
            Destroy(gameObject, 1f);

        }

        this.animator.SetBool("isSmashing", PlayerController.isSmashing);

    }

    void OnTriggerEnter2D(Collider2D col)
    {
        //if Mario runs into goomba he is dead
        if (col.name == "Mario" && !hasHitMario)
        {
            hasHitMario = true;
            GetComponent<CircleCollider2D>().enabled = false;
            GetComponent<EdgeCollider2D>().enabled = false;

        }

    }

    void OnTriggerExit2D()
    {
        hasHitMario = false;
    }


}//end script
