﻿using UnityEngine;
using System;
using System.Collections;
using System.IO.Ports;
using System.Threading;

public class SerialCommunication : MonoBehaviour 
{

    public static SerialPort sp = new SerialPort("COM3", 9600, Parity.None, 8, StopBits.One);

    //holds the accelerometer values
    public static int accValue = 0;
    public static int previousAccValue = 0;


    // Use this for initialization
    void Start () 
    {
        //not bother reopening if the port is already open
        if (!sp.IsOpen)
        {
            OpenConnection();
        }
        print ("Connection Successful!");
        sp.DiscardInBuffer();

    }//end start

    // Update is called once per frame
    void Update()
    {
        //save the value before getting a new one
        previousAccValue = accValue;

        //read a line coming from the com port only if port is open
        if (sp.IsOpen)
        {
            //try/catch in place in case we time out
            try
            {
                accValue = sp.ReadByte ();
                Debug.Log(accValue);
            }
            catch(TimeoutException) {}
        }

    }//end update


    public void OpenConnection() 
    {
        if (sp != null)
        {
            if (sp.IsOpen) 
            {
                sp.Close();
                print("Closing port, because it was already open!");
            }
            else 
            {
                sp.Open();  // opens the connection
                sp.ReadTimeout = 25;  // sets the timeout value before reporting error (in ms)
                //sp.WriteTimeout = 100;  // sets the timeout value before reporting error (in ms)
                print("Port Opened!");
            }
        }
        else
        {
            if (sp.IsOpen)
            {
                print("Port is already open");
            }
            else 
            {
                print("Port == null");
            }
        }
    }//end openConnection


    void OnApplicationQuit() 
    {
        if (sp.IsOpen)
        {
            print("connection closed!");
            sp.Close();
        }
    }

}//end script
