﻿using UnityEngine;
using System.Collections;

/*Script controller the behavior of goombas*/

public class TurtleController : MonoBehaviour 
{
    private Animator animator;

    public int turnTime;
    public int speed;

    public Collider2D[] boxColliders;

    public static bool hasHitMario = false;


    private bool hasHitWall = false;
    private bool hasChangedDirection = true;

    public LayerMask whatIsWall;
    public Transform groundCheck;
    public float groundCheckRadius;


    void Start () 
    {
        animator = GetComponent<Animator>();
        boxColliders = new Collider2D[2];
        boxColliders = gameObject.GetComponents<BoxCollider2D>();

    }//end start

    void FixedUpdate()
    {
        hasHitWall = Physics2D.OverlapCircle(groundCheck.position, groundCheckRadius, whatIsWall);

        if (hasHitWall)
        {
            hasChangedDirection = !hasChangedDirection;
        }

    }

    void Update ()
    {
        if (!PlayerController.isPaused)
        {
            Patrol();
            Stomp();
            //Kill();
        }
    }//end update


    void Patrol()
    {
        //just change directions if flag is set
        if (hasChangedDirection)
        {
            transform.Translate(-1 * speed * Time.deltaTime, 0f, 0f);
            transform.localScale = new Vector3(1f, 1f, 1f);
        }
        else if (!hasChangedDirection)
        {
            transform.Translate(speed * Time.deltaTime, 0f, 0f);
            transform.localScale = new Vector3(-1 * 1f, 1f, 1f);
        }

    }//end patrol

    void Kill()
    {
        if (boxColliders[1].name == "Goomba0")
        {
            PlayerController.isSmashing = true;
        }

    }
        

    void Stomp()
    {
        if (PlayerController.isSmashingTurtle)
        {
            if(!SoundEffects.stomp.isPlaying)
            {
                SoundEffects.stomp.Play();
            }
            speed = 10;
        }

        animator.SetBool("isSmashingTurtle", PlayerController.isSmashingTurtle);
    }

    void OnTriggerEnter2D(Collider2D col)
    {
        //if Mario runs into goomba he is dead
        if (col.name == "Mario" && !hasHitMario)
        {
            hasHitMario = true;
            boxColliders[0].enabled = false;
            boxColliders[1].enabled = false;
        }
    }

}//end script
